Barter/Models/UserSkill.cs
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Web;

namespace Barter.Models
{
    /// <summary>
    /// Представляє "скіл" конкретного юзера
    /// </summary>
    public class UserSkill
    {
        [Key]
        public int Id { get; set; }

        /// <summary>
        /// Посилання на підрубрику 
        /// </summary>
        public int SubrubricId { get; set; }

        [ForeignKey("SubrubricId")]
        public virtual Subrubric Subrubric { get; set; }


        /// <summary>
        /// Посилання на юзера
        /// </summary>
        [Required]
        public string UserId { get; set; }

        [ForeignKey("UserId")]
        public virtual ApplicationUser ApplicationUser { get; set; }

        [Required]
        public string Name { get; set; }

        public string Description { get; set; }

        public virtual ICollection<Feedback> Feedbacks { get; set; }
        public virtual ICollection<Request> Requests { get; set; }

        public virtual ICollection<Request> OutputRequests { get; set; }
    }
}

Barter/Models/UserSkillViewModel.cs
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;

namespace Barter.Models
{
    public class UserSkillViewModel
    {
        [Required]
        public int SubrubricId { get; set; }
       
        [Required]
        [Display(Name = "Key word")]
        public string Name { get; set; }

        [Display(Name = "Description")]
        public string Description { get; set; }
    }
}

Barter/Controllers/FeedbacksController.cs
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Net;
using System.Web;
using System.Web.Mvc;
using Barter.DAL;
using Barter.Models;
using Microsoft.AspNet.Identity;

namespace Barter.Controllers
{
    public class FeedbacksController : Controller
    {
        private UnitOfWork unitOfWork = null;

        public FeedbacksController()
        {
            unitOfWork = new UnitOfWork();
        }

        public FeedbacksController(UnitOfWork unitOfWork)
        {
            this.unitOfWork = unitOfWork;
        }

        // GET: Feedbacks   --- передати айдішку скіла
        public ActionResult Index(int userSkillId = 0)
        {
            return View(unitOfWork.Repository<Feedback>().GetAll() as IEnumerable<Feedback>);
        }

        // GET: Feedbacks/Create
        public ActionResult Create()
        {
            return View();
        }

        // POST: Feedbacks/Create
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see http://go.microsoft.com/fwlink/?LinkId=317598.
        // -- перевірити чи може коментити
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Create( Feedback feedback, int userSkillId)
        {
            if (feedback.Comment != String.Empty)
            {
                feedback.DateOfFeedback = DateTime.Now;
                feedback.UserSkillId = userSkillId;
                feedback.UserId = User.Identity.GetUserId();

                unitOfWork.Repository<Feedback>().Add(feedback);
                unitOfWork.SaveChanges();
                return RedirectToAction("Index");
            }
            
            return View(feedback);
        }

        //// GET: Feedbacks/Edit/5
        public ActionResult Edit(int id = 0)
        {
            Feedback feedback = unitOfWork.Repository<Feedback>().Get(c => c.Id == id);
            // якщо юзер написав даний коментар, то може його редагувати
            if(User.Identity.GetUserId() == feedback.UserId)
            {
                return View(feedback);
            }
            // дивиться далі коментарі
            return RedirectToAction("Index");
            
        }

        // POST: Feedbacks/Edit/5
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Edit( Feedback feedback)
        {
            if (ModelState.IsValid)
            {
                unitOfWork.Repository<Feedback>().Attach(feedback);
                unitOfWork.SaveChanges();
                return RedirectToAction("Index");
            }
   
            return View(feedback);
        }

        //// GET: Feedbacks/Delete/5
        public ActionResult Delete(int id = 0)
        {
            Feedback feedback = unitOfWork.Repository<Feedback>().Get(c => c.Id == id);
            if (feedback.UserId == User.Identity.GetUserId())
            {
                unitOfWork.Repository<Feedback>().Delete(feedback);
                unitOfWork.SaveChanges();
            }
            return RedirectToAction("Index");
        }


        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                unitOfWork.Dispose();
            }
            base.Dispose(disposing);
        }
    }
}

Barter/Controllers/RequestsController.cs
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Net;
using System.Web;
using System.Web.Mvc;
using Barter.DAL;
using Barter.Models;
using Microsoft.AspNet.Identity;

namespace Barter.Controllers
{
    public class RequestsController : Controller
    {
        private UnitOfWork unitOfWork = null;

        public RequestsController(UnitOfWork unitOfWork)
        {
            this.unitOfWork = unitOfWork;
        }

        public RequestsController()
        {
            unitOfWork = new UnitOfWork();
        }

        // GET: Requests
        public ActionResult Index()
        {
            return View(unitOfWork.Repository<Request>().GetAll() as IEnumerable<Request>);
        }

        // GET: Requests/Details/5
        public ActionResult Details(int id = 0)
        {
            Request request = unitOfWork.Repository<Request>().Get(c => c.Id == id);
            if (request == null)
            {
                return HttpNotFound();
            }
            return View(request);
        }

        // GET: Requests/Create
        [HttpGet]
        public ActionResult Create(int UserSkillToId)
        {
           // ViewBag.SkillToName = skill.Name;
            ViewBag.UserId = Guid.Parse(User.Identity.GetUserId());

            ViewBag.SkillToName = unitOfWork.Repository<UserSkill>().Get(s => s.Id == UserSkillToId).Name;

            ViewBag.SkillIdFrom = new SelectList(unitOfWork.Repository<UserSkill>().GetAll(sk => sk.UserId == User.Identity.GetUserId()) as IEnumerable<UserSkill>, "Id", "Name");
            return View();
        }

        // POST: Requests/Create
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Create(RequestViewModel requestView, int UserSkillToId = 0)
        {
            if (ModelState.IsValid)
            {
                string userId = User.Identity.GetUserId();

                var request = new Request()
                {
                    SkillIdFrom = requestView.SkillIdFrom,
                    SkillIdTo = UserSkillToId,
                    Message = requestView.Message,
                    DateOfSending = DateTime.Now,
                    Status = 0
                };
                unitOfWork.Repository<Request>().Add(request);
                unitOfWork.SaveChanges();
                return RedirectToAction("Index");
            }
            return View();
        }

        [HttpGet]
        public ActionResult Accept(int requestId)
        {
            Request request = unitOfWork.Repository<Request>().Get(c => c.Id == requestId);
            if (request == null)
            {
                return HttpNotFound();
            }

            request.Status = 1;
            unitOfWork.Repository<Request>().Attach(request);
            unitOfWork.SaveChanges();
            return RedirectToAction("Index");
        }

        [HttpGet]
        public ActionResult Deny(int requestId)
        {
            Request request = unitOfWork.Repository<Request>().Get(c => c.Id == requestId);
            if (request == null)
            {
                return HttpNotFound();
            }

            request.Status = -1;
            unitOfWork.Repository<Request>().Attach(request);
            unitOfWork.SaveChanges();
            return RedirectToAction("Index");
        }


        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                unitOfWork.Dispose();
            }
            base.Dispose(disposing);
        }
    }
}

Barter/Controllers/UserSkillsController.cs
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Net;
using System.Web;
using Microsoft.AspNet.Identity;
using System.Web.Mvc;
using Barter.DAL;
using Barter.Models;

namespace Barter.Controllers
{
    public class UserSkillsController : Controller
    {
        private UnitOfWork unitOfWork = null;

        public UserSkillsController()
        {
            unitOfWork = new UnitOfWork();
        }

        public UserSkillsController(UnitOfWork unitOfWork)
        {
            this.unitOfWork = unitOfWork;
        }

        // GET: UserSkills
        public ActionResult Index()
        {
            return View(unitOfWork.Repository<UserSkill>().GetAll() as IEnumerable<UserSkill>);
        }

        // GET: UserSkills/Details/5
        public ActionResult Details(int id = 0)
        {
            UserSkill skill = unitOfWork.Repository<UserSkill>().Get(c => c.Id == id);
            if (skill == null)
            {
                return HttpNotFound();
            }
            return View(skill);
        }

        // GET: UserSkills/Create
        public ActionResult Create()
        {
            ViewBag.UserId = Guid.Parse(User.Identity.GetUserId());
            ViewBag.SubrubricId = new SelectList(unitOfWork.Repository<Subrubric>().GetAll() as IEnumerable<Subrubric>, "Id", "Name");
            return View();
        }

        // POST: UserSkills/Create
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Create( UserSkillViewModel userSkill)
        {
            if (ModelState.IsValid)
            {
                string userId = User.Identity.GetUserId();

                var skill = new UserSkill() { Name = userSkill.Name,
                                              Description = userSkill.Description,
                                              UserId = userId,
                                              SubrubricId = userSkill.SubrubricId
                                             };
                unitOfWork.Repository<UserSkill>().Add(skill);
                unitOfWork.SaveChanges();
                return RedirectToAction("Index");
            }
            return View();
        }

        // GET: UserSkills/Edit/5
        public ActionResult Edit(int id = 0)
        {
            UserSkill skill = unitOfWork.Repository<UserSkill>().Get(c => c.Id == id);
            if (skill == null)
            {
                return HttpNotFound();
            }
            ViewBag.SubrubricId = new SelectList(unitOfWork.Repository<Subrubric>().GetAll() as IEnumerable<Subrubric>, "Id", "Name", skill.SubrubricId);
            return View(skill);
            
        }

        // POST: UserSkills/Edit/5
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Edit(UserSkill userSkill)
        {
            if (userSkill.Name != string.Empty)
            {
                unitOfWork.Repository<UserSkill>().Attach(userSkill);
                unitOfWork.SaveChanges();
                return RedirectToAction("Index");
            }
            return View(userSkill);
          
        }

        [HttpGet]
        [ValidateAntiForgeryToken]
        public ActionResult MakeRequest(int id =0)
        {
            UserSkill skill = unitOfWork.Repository<UserSkill>().Get(c => c.Id == id);
            if (skill == null)
            {
                return HttpNotFound();
            }
            ViewBag.SkillToName = skill.Name;
            return RedirectToAction("Create", "RequestController", new { UserSkillToId = id });
        }

        // GET: UserSkills/Delete/5
        public ActionResult Delete(int id = 0)
        {
            UserSkill skill = unitOfWork.Repository<UserSkill>().Get(c => c.Id == id);
            if (skill == null)
            {
                return HttpNotFound();
            }
            return View(skill);
        }

        // POST: UserSkills/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public ActionResult DeleteConfirmed(int id)
        {
            UserSkill skill = unitOfWork.Repository<UserSkill>().Get(c => c.Id == id);
            unitOfWork.Repository<UserSkill>().Delete(skill);
            unitOfWork.SaveChanges();
            return RedirectToAction("Index");
        }

        [HttpGet]
        public ActionResult Feedback(int userSkillid = 0)
        {
            return RedirectToAction("Create", "Feedbacks", new { userSkillId = userSkillid });
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                unitOfWork.Dispose();
            }
            base.Dispose(disposing);
        }
    }
}

Barter/Views/UserSkills/Create.cshtml
@model Barter.Models.UserSkillViewModel

@{
    ViewBag.Title = "Create";
}

<h2>Create</h2>


@using (Html.BeginForm()) 
{
    @Html.AntiForgeryToken()
    
    <div class="form-horizontal">
        <h4>UserSkill</h4>
        <hr />
        @Html.ValidationSummary(true, "", new { @class = "text-danger" })
        <div class="form-group">
            @Html.LabelFor(model => model.SubrubricId, "SubrubricId", htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.DropDownList("SubrubricId", null, htmlAttributes: new { @class = "form-control" })
                @Html.ValidationMessageFor(model => model.SubrubricId, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Name, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Name, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Name, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Description, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Description, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Description, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            <div class="col-md-offset-2 col-md-10">
                <input type="submit" value="Create" class="btn btn-default" />
            </div>
        </div>
    </div>
}

<div>
    @Html.ActionLink("Back to List", "Index")
</div>

@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
}

Barter/Views/UserSkills/Delete.cshtml
@model Barter.Models.UserSkill

@{
    ViewBag.Title = "Delete";
}

<h2>Delete</h2>

<h3>Are you sure you want to delete this?</h3>
<div>
    <h4>UserSkill</h4>
    <hr />
    <dl class="dl-horizontal">
        <dt>
            @Html.DisplayNameFor(model => model.ApplicationUser.LName)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.ApplicationUser.LName)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Subrubric.Name)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Subrubric.Name)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Name)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Name)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Description)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Description)
        </dd>

    </dl>

    @using (Html.BeginForm()) {
        @Html.AntiForgeryToken()

        <div class="form-actions no-color">
            <input type="submit" value="Delete" class="btn btn-default" /> |
            @Html.ActionLink("Back to List", "Index")
        </div>
    }
</div>

Barter/Views/UserSkills/Details.cshtml
@model Barter.Models.UserSkill

@{
    ViewBag.Title = "Details";
}

<h2>Details</h2>

<div>
    <h4>UserSkill</h4>
    <hr />
    <dl class="dl-horizontal">
        <dt>
            @Html.DisplayNameFor(model => model.ApplicationUser.LName)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.ApplicationUser.LName)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Subrubric.Rubric.Name)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Subrubric.Rubric.Name)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Subrubric.Name)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Subrubric.Name)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Name)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Name)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Description)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Description)
        </dd>

    </dl>
</div>
<p>
    @Html.ActionLink("Edit", "Edit", new { id = Model.Id }) |
    @Html.ActionLink("Back to List", "Index")
</p>

Barter/Views/UserSkills/Edit.cshtml
@model Barter.Models.UserSkill

@{
    ViewBag.Title = "Edit";
}

<h2>Edit</h2>


@using (Html.BeginForm())
{
    @Html.AntiForgeryToken()
    
    <div class="form-horizontal">
        <h4>UserSkill</h4>
        <hr />
        @Html.ValidationSummary(true, "", new { @class = "text-danger" })
        @Html.HiddenFor(model => model.Id)
        @Html.HiddenFor(model => model.UserId)

        <div class="form-group">
            @Html.LabelFor(model => model.SubrubricId, "SubrubricId", htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.DropDownList("SubrubricId", null, htmlAttributes: new { @class = "form-control" })
                @Html.ValidationMessageFor(model => model.SubrubricId, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Name, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Name, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Name, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Description, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Description, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Description, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            <div class="col-md-offset-2 col-md-10">
                <input type="submit" value="Save" class="btn btn-default" />
            </div>
        </div>
    </div>
}

<div>
    @Html.ActionLink("Back to List", "Index")
</div>

@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
}

Barter/Views/UserSkills/Index.cshtml
@model IEnumerable<Barter.Models.UserSkill>

@{
    ViewBag.Title = "Index";
}

<h2>Index</h2>

<p>
    @Html.ActionLink("Create New", "Create")
</p>
<table class="table">
    <tr>
        <th>
            @Html.DisplayNameFor(model => model.ApplicationUser.LName)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.Subrubric.Rubric.Name)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.Subrubric.Name)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.Name)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.Description)
        </th>
        <th></th>
    </tr>

@foreach (var item in Model) {
    <tr>
        <td>
            @Html.DisplayFor(modelItem => item.ApplicationUser.LName)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.Subrubric.Rubric.Name)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.Subrubric.Name)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.Name)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.Description)
        </td>
        <td>
            @Html.ActionLink("Edit", "Edit", new { id=item.Id }) |
            @Html.ActionLink("Details", "Details", new { id=item.Id }) |
            @Html.ActionLink("Delete", "Delete", new { id=item.Id })
            @Html.ActionLink("MakeRequest", "Create", "Requests", new {UserSkillToId = item.Id}, null)
            @Html.ActionLink("Feedback", "Feedback", new { userSkillId = item.Id })
            @Html.ActionLink("View all feedbacks", "Index", "Feedbacks", new { userSkillId  = item.Id})
        </td>
    </tr>
}

</table>